.386
.model flat,stdcall
option casemap:none
include c:\masm32\include\windows.inc
include c:\masm32\include\user32.inc
include c:\masm32\include\kernel32.inc
include \masm32\include\gdi32.inc

includelib c:\masm32\lib\user32.lib
includelib c:\masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib

include \masm32\macros\macros.asm

DrawProgress	PROTO	:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

.code
DrawProgress	proc	uses edi esi ebx hDC:DWORD,font:DWORD,height:DWORD,pos:DWORD,maxi:DWORD,left:DWORD,top:DWORD,model:DWORD,text:DWORD,String:DWORD
LOCAL	pixel:DWORD
LOCAL	hBrush1,hBrush2,hBrush3,hBrush4,hBrush5,hBrush6:DWORD
LOCAL	hPen1,hPen2,hPen3:DWORD
LOCAL	sPen1:DWORD
LOCAL	sBrush6:DWORD
LOCAL	sFont:DWORD
LOCAL	sTxtColor:DWORD
LOCAL	sBkColor:DWORD
LOCAL	szPoint[16h]:DWORD
LOCAL	szBuf[8]:BYTE
LOCAL percent[20]:DWORD
LOCAL percentdb[20]:BYTE
LOCAL	pencolor1:DWORD
LOCAL	pencolor2:DWORD

jmp @F
      conv			db		"%lu%%",0
      color0a		dd		0FF8080h
      color0b		dd		0E06868h
      color1a		dd		008080FFh
      color1b		dd		005757FFh
      color2a		dd		0000C100h
      color2b		dd		00008000h
      color3a		dd		00FFC1C1h;00FFACACh
      color3b		dd		00EA9191h;00E68282h

@@:
	mov eax, maxi ; max percent == 100 %
	.if eax < pos
	mov pos, eax
	.endif 
      
	.if model == 1
	m2m pencolor1,color1a
	m2m pencolor2,color1b
	.elseif model == 2
	m2m pencolor1,color2a
	m2m pencolor2,color2b
	.elseif model == 3
	m2m pencolor1,color3a
	m2m pencolor2,color3b
	.else ; default color
	m2m pencolor1,color0a
	m2m pencolor2,color0b
	.endif
      

	xor	ebx,ebx		; PS_SOLID
	push	1
	pop	esi
	mov	edi,CreatePen
	push	0FFE0E0h ; contours
	push	esi
	push	ebx
	call	edi
	mov	hPen1, eax
	push	8060A0h ; contours
	push	esi
	push	ebx
	call	edi
	mov	hPen2, eax
	push	64408Ch ; contours
	push	esi
	push	ebx
	call	edi
	mov	hPen3, eax

	mov	esi,CreateSolidBrush
	push	pencolor1
	call	esi
	mov	hBrush1, eax
	push	8848C0h
	call	esi
	mov	hBrush2, eax
	push	0A060A0h
	call	esi
	mov	hBrush3, eax
	push	7A408Ch
	call	esi
	mov	hBrush4, eax
	push	823C96h
	call	esi
	mov	hBrush5, eax
	push	pencolor2
	call	esi
	mov	hBrush6, eax

	mov	edi,SelectObject
	mov	esi, hDC
	push	hPen1
	push	esi
	call	edi
	mov	sPen1, eax
	push	hBrush6
	push	esi
	call	edi
	mov	sBrush6, eax


	add	top,9		; mala korekta
	sub	height,16

	mov	ebx, top
	mov	edi,height
	mov	ecx,maxi ; valeur maximum
	mov	eax, pos
	imul	edi
	cdq
	idiv	ecx
	lea	edx, [ebx+edi]
	sub	edx, eax
	mov	pixel, edx


	.if	text >0  && text <3
	invoke	SelectObject,esi,font
	mov	sFont,eax
	.endif

	invoke	SetTextColor,esi,80005Ch ;color text
	mov	sTxtColor, eax
	invoke	GetSysColor,15
	invoke	SetBkColor,esi,eax
	mov	sBkColor, eax

	.if	text==1 ; text affiche
	invoke lstrlen,String
	mov	ecx, pixel
	add	ecx, 0FFFFFFF6h
	mov	edx,25h
	add	edx,left
	invoke	TextOutA,esi,edx,ecx,String,eax

	invoke	SetTextColor,esi,sTxtColor
	invoke	SetBkColor,esi,sBkColor
	invoke	SelectObject,esi,sFont
	.endif

	.if	text==2 ; calcul du pourcentage en fonction de la taille maxi
      mov eax, pos
      xor edx, edx
      mov ecx, 100 ; On multiplie par cent...
      mul ecx
      xor edx, edx ; ...et divise par maxi.
      mov ecx, maxi 
      div ecx 
      mov percent, eax

      invoke	wsprintfA,addr percentdb,offset conv,percent
      invoke	lstrlen,addr percentdb

	mov	ecx, pixel
	add	ecx, 0FFFFFFF6h
	mov	edx,25h
	add	edx,left
	invoke	TextOutA,esi,edx,ecx,addr percentdb,eax

	invoke	SetTextColor,esi,sTxtColor
	invoke	SetBkColor,esi,sBkColor
	invoke	SelectObject,esi,sFont
	.endif


	xor	eax,eax
	lea	edi,szPoint
	mov	ecx,8
	rep	stosd

	mov	eax, pixel
	add	eax, 0FFFFFFF6h
	lea	esi, szPoint
	mov	byte ptr [esi],14h
	mov	byte ptr [esi+8],5
	mov	byte ptr [esi+16],5
	mov	byte ptr [esi+24],14h

	mov	[esi+4], eax
	lea	ecx, [ebx-5]
	mov	edx, pixel
	add	edx, 0FFFFFFFBh
	mov	[esi+12],edx
	mov	[esi+20],ecx
	mov	[esi+28],ebx

	mov	ecx, left
	add	[esi],ecx
	add	[esi+8],ecx
	add	[esi+16],ecx
	add	[esi+24],ecx

	invoke	Polygon,hDC,esi,4
	invoke	SelectObject,hDC,hBrush1


	xor	eax,eax
	lea	edi, szPoint
	mov	ecx, 8
	rep	stosd
	lea	esi, szPoint
	mov	byte ptr [esi],14h
	mov	byte ptr [esi+8],23h
	mov	byte ptr [esi+16],23h
	mov	byte ptr [esi+24],14h

	mov	eax, pixel
	add	eax, 0FFFFFFF6h
	lea	esi, szPoint
	mov	[esi+4],eax
	lea	ecx, [ebx-5]
	mov	edx, pixel
	add	edx, 0FFFFFFFBh
	mov	[esi+12],edx
	mov	[esi+20],ecx
	mov	[esi+28],ebx

	mov	ecx, left
	add	[esi],ecx
	add	[esi+8],ecx
	add	[esi+16],ecx
	add	[esi+24],ecx

	invoke	Polygon,hDC,esi,4

	xor	eax,eax
	lea	edi, szPoint
	mov	ecx, 8
	rep	stosd
	lea	esi, szPoint
	mov	byte ptr [esi],5
	mov	byte ptr [esi+8],14h
	mov	byte ptr [esi+16],23h
	mov	byte ptr [esi+24],14h


	lea	eax, [ebx-5]
	lea	esi, szPoint
	mov	[esi+4],eax
	lea	edx, [ebx-0Ah]
	mov	[esi+12], edx
	lea	ecx, [ebx-5]
	mov	[esi+20], ecx
	mov	[esi+28], ebx

	mov	ecx, left
	add	[esi],ecx
	add	[esi+8],ecx
	add	[esi+16],ecx
	add	[esi+24],ecx

	invoke	Polygon,hDC,esi,4

	mov	esi, hDC
	mov	edi,SelectObject
	push	hPen1
	push	esi
	call	edi
	push	hBrush5
	push	esi
	call	edi


	xor	eax,eax
	lea	edi, szPoint
	mov	ecx, 8
	rep	stosd
	lea	esi, szPoint
	mov	byte ptr [esi],14h
	mov	byte ptr [esi+8],5h
	mov	byte ptr [esi+16],5h
	mov	byte ptr [esi+24],14h

	mov	edi, height
	lea	eax, [ebx+edi]
	lea	edx, [ebx+edi]
	add	eax, 5
	lea	esi, szPoint
	mov	[esi+4], eax
	mov	[esi+12],edx
	mov	ecx, pixel
	add	ecx, 0FFFFFFFBh
	mov	[esi+20], ecx
	mov	eax, pixel
	mov	[esi+28], eax

	mov	ecx, left
	add	[esi],ecx
	add	[esi+8],ecx
	add	[esi+16],ecx
	add	[esi+24],ecx

	invoke	Polygon,hDC,esi,4
	invoke	SelectObject,hDC,hBrush2

	xor	eax,eax
	lea	edi, szPoint
	mov	ecx, 8
	rep	stosd

	lea	esi, szPoint
	mov	byte ptr [esi],14h
	mov	byte ptr [esi+8],23h
	mov	byte ptr [esi+16],23h
	mov	byte ptr [esi+24],14h

	mov	edi, height
	lea	eax, [ebx+edi+5]
	lea	edx, [ebx+edi]
	lea	esi, szPoint
	mov	[esi+4], eax
	mov	[esi+12],edx
	mov	ecx, pixel
	add	ecx, 0FFFFFFFBh
	mov     [esi+20], ecx
	mov	eax, pixel
	mov	[esi+28],eax

	mov	ecx, left
	add	[esi],ecx
	add	[esi+8],ecx
	add	[esi+16],ecx
	add	[esi+24],ecx

	invoke	Polygon,hDC,esi,4

	mov	esi, hDC
	mov	edi,SelectObject
	push	hPen3
	push	esi
	call	edi
	push	hBrush4
	push	esi
	call	edi

	xor	eax,eax
	lea	edi, szPoint
	mov	ecx, 8
	rep	stosd

	lea	esi, szPoint
	mov	byte ptr [esi],14h
	mov	byte ptr [esi+8],23h
	mov	byte ptr [esi+16],14h
	mov	byte ptr [esi+24],5h


	mov	edi, height
	lea	eax, [ebx+edi+5]
	lea	edx, [ebx+edi]
	lea	esi, szPoint
	mov	[esi+4],eax
	lea	ecx, [ebx+edi]
	mov	[esi+12], edx
	add	ecx, 0FFFFFFFBh
	mov	[esi+20], ecx
	lea	eax, [ebx+edi]
	mov	[esi+28], eax

	mov	ecx, left
	add	[esi],ecx
	add	[esi+8],ecx
	add	[esi+16],ecx
	add	[esi+24],ecx

	invoke	Polygon,hDC,esi,4

	mov	esi, hDC
	mov	edi,SelectObject
	push	hPen2
	push	esi
	call	edi
	push	hBrush3
	push	esi
	call	edi

	xor	eax,eax
	lea	edi, szPoint
	mov	ecx, 8
	rep	stosd

	lea	esi, szPoint
	mov	byte ptr [esi],14h
	mov	byte ptr [esi+8],5h
	mov	byte ptr [esi+16],14h
	mov	byte ptr [esi+24],23h

	mov	eax, pixel
	lea	esi, szPoint
	mov	[esi+4],eax
	mov	edx, pixel
	add	edx, 0FFFFFFFBh
	mov	[esi+12], edx
	mov	ecx, pixel
	add	ecx, 0FFFFFFF6h
	mov	[esi+20], ecx
	mov	eax, pixel
	add	eax, 0FFFFFFFBh
	mov	[esi+28], eax

	mov	ecx, left
	add	[esi],ecx
	add	[esi+8],ecx
	add	[esi+16],ecx
	add	[esi+24],ecx

	invoke	Polygon,hDC,esi,4
	invoke	SelectObject,hDC,hPen1

	xor	eax,eax
	lea	edi, szPoint
	mov	ecx, 16h
	rep	stosd

	lea	esi, szPoint
	mov	byte ptr [esi],14h
	mov	byte ptr [esi+8],5h
	mov	byte ptr [esi+16],5
	mov	byte ptr [esi+24],14h
	mov	byte ptr [esi+32],14h
	mov	byte ptr [esi+40],23h
	mov	byte ptr [esi+48],23h
	mov	byte ptr [esi+56],14h
	mov	byte ptr [esi+64],5
	mov	byte ptr [esi+72],14h
	mov	byte ptr [esi+80],23h


	lea	esi, szPoint
	mov	edi, height
	lea	ecx, [ebx-5]
	lea	eax, [ebx+edi+5]
	mov	[esi+4],eax

	lea	edx, [ebx+edi]
	mov	[esi+12],edx
	mov	[esi+20],ecx
	mov	[esi+28],ebx
	lea	eax, [ebx+edi+5]
	mov	[esi+36], eax
	lea	edx, [ebx+edi]
	mov	[esi+44],edx
	lea	ecx, [ebx-5]
	mov	[esi+52], ecx
	mov	[esi+60], ebx
	lea	eax, [ebx-5]
	lea	edx, [ebx-0Ah]
	mov	[esi+68],eax
	mov	[esi+76], edx
	add	ebx, 0FFFFFFFBh
	mov	[esi+84], ebx

	mov	ecx, left
	add	[esi],ecx
	add	[esi+8],ecx
	add	[esi+16],ecx
	add	[esi+24],ecx
	add	[esi+32],ecx
	add	[esi+40],ecx
	add	[esi+48],ecx
	add	[esi+56],ecx
	add	[esi+64],ecx
	add	[esi+72],ecx
	add	[esi+80],ecx

	invoke	Polyline,hDC,esi,11

	mov	edi,DeleteObject

	push	hPen1
	push	hPen2
	push	hPen3
	push	hBrush1
	push	hBrush2
	push	hBrush3
	push	hBrush4
	push	hBrush5
	push	hBrush6

	call	edi
	call	edi
	call	edi
	call	edi
	call	edi
	call	edi
	call	edi
	call	edi
	call	edi

	ret
DrawProgress	endp
end
