.386
.MODEL 	FLAT,STDCALL
option 	casemap:none
include	DProgress.inc


.code

Entrypoint:
	mov hInstance,FUNC (GetModuleHandle, NULL)
	invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DLG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0
       
DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	idThread:DWORD
	LOCAL	Paint:PAINTSTRUCT
      
	mov		eax,uMsg
	.If eax==WM_INITDIALOG
		m2m hWnd, hWin
		invoke SendDlgItemMessage,hWin,IDC_TRB1,TBM_SETRANGEMIN,FALSE,0
		invoke SendDlgItemMessage,hWin,IDC_TRB1,TBM_SETRANGEMAX,FALSE,50
		invoke SendDlgItemMessage,hWin,IDC_TRB1,TBM_SETPOS,25,25
		mov count, 100
		mov speed, 25
		return 0

	.elseif eax==WM_HSCROLL
		invoke SendDlgItemMessage,hWin,IDC_TRB1,TBM_GETPOS,0,0
		mov speed, eax

 	.elseif eax==WM_PAINT
		mov	hdc, FUNC (BeginPaint,hWnd,addr Paint)	
		
		push 	0			; Text
		push 	0			; 0 == no text, 1== show text, 2 == show percent  
		push 	0			; Model color: 0 == blue, 1 == red, 2 == green, 3 == light blue
		push 	20			; top
		push 	83			; left
      	push 	100			; maxi
		push 	count 		; pos
		push 	200			; height
		push 	0			; hFont (default = 0)
		push 	hdc			; hDC
		call 	DrawProgress
		return 0		
		
	.Elseif eax==WM_COMMAND		
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if edx==BN_CLICKED
			.if eax==IDC_START
				.if pos == 0
					mov pos,1
					invoke CreateThread,0,2000,ADDR ThreadDraw,0,0,ADDR idThread
					fn SendDlgItemMessage,hWnd,IDC_START,WM_SETTEXT,0,"STOP"
				.elseif pos == 1
					mov pos,0
					fn SendDlgItemMessage,hWnd,IDC_START,WM_SETTEXT,0,"START"
				.endif
			.endif	
		.endif	
			
	.elseif eax==WM_CLOSE
		invoke DeleteObject,hdc
		invoke EndDialog,hWin,0
	.Else
		return 0
	.Endif
	return 1	
DlgProc endp

ThreadDraw PROC
	LOCAL model:DWORD
	
	mov model, 0
	.WHILE pos == 1 ;if STOP exit Thread
		dec count
		.if model > 14  && model < 28 ;blue or light blue ? :-)
			invoke DrawProgress,hdc,0,200,count,100,83,20,3,0,0		
		.else	
			invoke DrawProgress,hdc,0,200,count,100,83,20,0,0,0	
		.endif	
		invoke Sleep, speed ;speed trackbar
		.if model == 28
			mov model,0
		.else	
			inc model	
		.endif
		.if count == 0 ; restart
			mov count, 100
		.endif	
	.ENDW
	ret
ThreadDraw endp

end Entrypoint