.386
.MODEL 	FLAT,STDCALL
option 	casemap:none
include	DProgress.inc


.code

start:
	mov hInstance,FUNC (GetModuleHandle, NULL)
	invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DLG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0
       
DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	idThread:DWORD
	LOCAL	Paint:PAINTSTRUCT
      
	mov		eax,uMsg
	.If eax==WM_INITDIALOG
		m2m hWnd, hWin
		mov count, 0
		return 0

 	.elseif eax==WM_PAINT
		mov	hdc, FUNC (BeginPaint,hWnd,addr Paint)

		push 	0			; Text
		push 	0			; 0 == no text, 1== show text, 2 == show percent  
		push 	1			; Model color: 0 == blue, 1 == red, 2 == green, 3 == light blue			
		push 	90			; top
		push 	40			; left
      	push 	1000		; maxi
		push 	count 		; pos
		push 	160			; height
		push 	0			; hFont (default = 0)
		push 	hdc			; hDC
		call 	DrawProgress
		
		invoke wsprintf, addr buff, addr conv, count
		invoke SendDlgItemMessage,hWnd,IDC_COUNT,WM_SETTEXT,0,addr buff
		
		push 	0	
		push 	0		
		push 	0
		push 	90		
		push 	180		
      	push 	1000			
		push 	count 	
		push 	160		
		push 	0		
		push 	hdc		
		call 	DrawProgress		
		return 0
		
	.Elseif eax==WM_COMMAND		
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if edx==BN_CLICKED
			.if eax==IDC_START
				.if count == 0
					invoke CreateThread,0,2000,ADDR ThreadDraw,0,0,ADDR idThread
				.endif
			.endif
		.endif	
			
	.elseif eax==WM_CLOSE
		invoke DeleteObject,hdc
		invoke EndDialog,hWin,0
	.Else
		return 0
	.Endif
	return 1	


DlgProc endp


ThreadDraw PROC
	.While count < 1001
		invoke DrawProgress, hdc,0,160,count,1000,40,90,1,2,0
		invoke DrawProgress, hdc,0,160,count,1000,180,90,0,0,0
		invoke wsprintf, addr buff, addr conv, count
		invoke SendDlgItemMessage,hWnd,IDC_COUNT,WM_SETTEXT,0,addr buff		
		invoke Sleep, 200	
		add count,50
	.ENDW	
	ret
ThreadDraw endp

end start