.386
.MODEL 	FLAT,STDCALL
option 	casemap:none
include	DProgress.inc

.code

start:
	mov hInstance,FUNC (GetModuleHandle, NULL)
	invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DLG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0
       

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	idThread:DWORD
	LOCAL	Paint:PAINTSTRUCT   
	   
	mov		eax,uMsg
	.If eax==WM_INITDIALOG
		m2m hWnd, hWin
		fn CreateFontA,16,0,0,0,FW_BLACK,0,0,0,0,0,0,PROOF_QUALITY,0,"Times New Roman"
		mov hFont, eax
		
		invoke SendDlgItemMessage,hWnd,1001,BM_SETIMAGE,IMAGE_BITMAP,FUNC (LoadBitmap,hInstance,201)	
		mov PBrushD,FUNC (CreatePatternBrush,FUNC (LoadBitmap, hInstance, Texture))
		mov PBrushD2,FUNC (CreatePatternBrush,FUNC (LoadBitmap, hInstance, Texture2))
		mov PBrushD3,FUNC (CreatePatternBrush,FUNC (LoadBitmap, hInstance, 202))
		fn SendMessage,FUNC (GetDlgItem,hWnd,IDC_STC2),WM_SETFONT,hFont, 0
		fn SendMessage,FUNC (GetDlgItem,hWnd,IDC_STC3),WM_SETFONT,hFont, 0 
		fn SendMessage,FUNC (GetDlgItem,hWnd,IDC_STC4),WM_SETFONT,hFont, 0 
		fn SendMessage,FUNC (GetDlgItem,hWnd,IDC_STC5),WM_SETFONT,hFont, 0 
		invoke VolumeInfo
		return 0

 	.elseif 	Eax==WM_PAINT
		mov	hdc, FUNC (BeginPaint,hWnd,addr Paint)
		mov esi, FUNC (atodw, addr numbuff2) ;pos
		invoke	atodw, addr numbuff1 ;maxi
		sub eax, esi
		mov esi, eax	
		fn DrawProgress, hdc,hFont,180,esi,FUNC (atodw, addr numbuff1),30,80,0,2,0
		return 0
		
	.ElseIf 	Eax == WM_CTLCOLORDLG 
		mov eax,PBrushD
		ret	
					
	.ElseIf 	Eax == WM_CTLCOLORSTATIC
			Invoke 	SetBkMode, wParam, TRANSPARENT
			Invoke 	SetTextColor, wParam, 00FFC1C1h
			mov eax,PBrushD2
			ret	
					
	.Elseif 	Eax==WM_COMMAND		
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if edx==BN_CLICKED
			.if eax==IDC_EXIT
				invoke DeleteObject,hdc
				invoke EndDialog,hWin,0
			.endif	
		.endif	
			
	.elseif 	Eax==WM_CLOSE
		invoke DeleteObject,hdc
		invoke EndDialog,hWin,0
	.Else
		return 0
	.Endif
	return 1	
DlgProc endp

VolumeInfo PROC
	LOCAL Volume[5]:BYTE
	LOCAL info[256]:BYTE
	LOCAL lpVolumeNameBuffer[MAX_PATH]:BYTE
	LOCAL PartLow:DWORD
	LOCAL PartHigh:DWORD
	LOCAL lpVolumeSerialNumber:DWORD
	LOCAL lpMaximumComponentLength:DWORD
	LOCAL lpFileSystemFlags:DWORD    
	LOCAL lpFileSystemNameBuffer:DWORD  
	LOCAL nFileSystemNameSize:DWORD
	LOCAL AvailableToCaller:QWORD 
	LOCAL TotalBytesUsed:QWORD
	
  	invoke GetSystemDirectory,addr info, sizeof info
  	invoke lstrcpyn, addr Volume, addr info, 4
	
  	invoke GetVolumeInformation, addr Volume, addr lpVolumeNameBuffer, sizeof lpVolumeNameBuffer,addr lpVolumeSerialNumber ,addr lpMaximumComponentLength, addr lpFileSystemFlags , addr lpFileSystemNameBuffer, 25  
	invoke GetDiskFreeSpaceEx, addr Volume, addr AvailableToCaller, addr TotalBytesUsed, NULL
	mov eax, DWORD PTR TotalBytesUsed 
	mov edx, DWORD PTR TotalBytesUsed + 4
	div Big10
	mov PartLow, edx 
	mov PartHigh, eax

	mov eax,PartLow ; division pour Mo...
	xor edx, edx 
	mov ecx, 1000000 
	div ecx 
	mov PartLow, eax
	fn wsprintf, addr numbuff1,"%d%.3d",PartHigh,PartLow
 
	mov eax, DWORD PTR AvailableToCaller 
	mov edx, DWORD PTR AvailableToCaller + 4
	div Big10
	mov PartLow, edx 
	mov PartHigh, eax

	mov eax,PartLow
	xor edx, edx 
	mov ecx, 1000000 ; division pour Mo...
	div ecx 
	mov PartLow, eax
	fn wsprintf, addr numbuff2,"%d%.3d",PartHigh,PartLow
	
	invoke RtlZeroMemory,addr info, sizeof info
  	fn szMultiCat, 2, addr info," Volume : ", addr Volume
  	invoke SendDlgItemMessage,hWnd,IDC_STC2,WM_SETTEXT,0,addr info
  	invoke RtlZeroMemory,addr info, sizeof info
  	fn szMultiCat, 2, addr info," Name : ",addr lpVolumeNameBuffer
  	invoke SendDlgItemMessage,hWnd,IDC_STC3,WM_SETTEXT,0,addr info
  	invoke RtlZeroMemory,addr info, sizeof info
  	fn szMultiCat, 3, addr info," Total : ", addr numbuff1," Mo "
  	invoke SendDlgItemMessage,hWnd,IDC_STC4,WM_SETTEXT,0,addr info
  	invoke RtlZeroMemory,addr info, sizeof info
  	fn szMultiCat, 3, addr info," Free : ", addr numbuff2," Mo "
  	invoke SendDlgItemMessage,hWnd,IDC_STC5,WM_SETTEXT,0,addr info	       
  	ret
VolumeInfo ENDP 

end start